/* GtkJentchina
 * STRASSER Michel - 20040312		init
 * */


#include "GJnaFsdIFInfo.h"
#include <glib.h>
#include <glib-object.h>
#include <gnome.h>

static GObjectClass *gjnaFsdIFInfo_parentClass;

static void
impl_GJnaFsdIFInfo_finalize(GObject *object)
{
	GJnaFsdIFInfo *self=(GJnaFsdIFInfo*)object;
	int i;
	
	gtk_widget_hide(GTK_WIDGET(self));
	
	for(i=0 ; i < GJnaFsdIFInfoKeyValueWidgets_LAST ; i++) {
		g_object_unref(G_OBJECT(self->keyValue[i].key));
		g_object_unref(G_OBJECT(self->keyValue[i].value));
	}

	gjnaFsdIFInfo_parentClass->finalize(object);
}

static void
GJnaFsdIFInfoClass_init (GJnaFsdIFInfoClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	gjnaFsdIFInfo_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_GJnaFsdIFInfo_finalize;
}

GType		GJnaFsdIFInfo_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (GJnaFsdIFInfoClass),
			NULL, NULL,
			(GClassInitFunc) GJnaFsdIFInfoClass_init,
			NULL, NULL,
			sizeof (GJnaFsdIFInfo),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			GTK_TYPE_TABLE,
			"GJnaFsdIFInfo", &info, 0);
	}

	return type;
}

static void
impl_GJnaFsdIFInfo_addLabel		(GJnaFsdIFInfo* self,
					 GJnaFsdIFInfoKeyValueWidgetsNum num,
					 char* label)
{
	self->keyValue[num].key = gtk_label_new (label); 
	gtk_widget_ref (self->keyValue[num].key); 
	gtk_widget_show (self->keyValue[num].key); 
	gtk_table_attach (GTK_TABLE (self), self->keyValue[num].key, 0, 1, num*2, num*2 + 1, 
	                  (GtkAttachOptions) (GTK_FILL), 
	                    (GtkAttachOptions) (0), 0, 0); 
	gtk_misc_set_alignment (GTK_MISC (self->keyValue[num].key), 0, 0.5); 
}

static void
impl_GJnaFsdIFInfo_addEntry		(GJnaFsdIFInfo* self,
					 GJnaFsdIFInfoKeyValueWidgetsNum num,
					 char* label)
{
	impl_GJnaFsdIFInfo_addLabel(self, num, label);
	
	self->keyValue[num].value = G_OBJECT(gtk_entry_new ()); 
	g_object_ref (self->keyValue[num].value); 
	gtk_widget_show (GTK_WIDGET(self->keyValue[num].value)); 
	gtk_table_attach (GTK_TABLE (self), GTK_WIDGET(self->keyValue[num].value), 1, 2, num*2, num*2 + 1, 
	                  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 
	                  (GtkAttachOptions) (0), 0, 0); 
	gtk_entry_set_editable(GTK_ENTRY(self->keyValue[num].value), FALSE); 
	gtk_entry_set_text(GTK_ENTRY(self->keyValue[num].value), ""); 
}
	
static void
impl_GJnaFsdIFInfo_addText		(GJnaFsdIFInfo* self,
					 GJnaFsdIFInfoKeyValueWidgetsNum num,
					 char* label)
{
	GtkWidget* textView;
	GtkWidget* scrolledWindow;

	impl_GJnaFsdIFInfo_addLabel(self, num, label);

	scrolledWindow = gtk_scrolled_window_new (NULL, NULL);
  	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledWindow), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
	gtk_widget_ref(scrolledWindow);
	gtk_widget_show(scrolledWindow);
	gtk_table_attach (GTK_TABLE (self), scrolledWindow, 1, 2, num*2, num*2 + 1,
	                  (GtkAttachOptions) (GTK_FILL),
	                  (GtkAttachOptions) (GTK_FILL), 0, 0);

	self->keyValue[num].value = G_OBJECT(gtk_text_buffer_new (NULL)); 
	g_object_ref (self->keyValue[num].value); 

	textView=gtk_text_view_new_with_buffer((GtkTextBuffer*)(self->keyValue[num].value));
	gtk_text_view_set_editable(GTK_TEXT_VIEW(textView), FALSE);
	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(textView), GTK_WRAP_WORD); 
	g_object_ref(G_OBJECT(textView));
	gtk_widget_show (GTK_WIDGET(textView));
	gtk_container_add (GTK_CONTAINER(scrolledWindow), textView);

	g_object_set_data_full(G_OBJECT(self->keyValue[num].value), "textView", textView, g_object_unref);
	g_object_set_data_full(G_OBJECT(self->keyValue[num].value), "scrolledWindow", scrolledWindow, g_object_unref);
}
					 
GObject* 	
GJnaFsdIFInfo_new			()
{
	GJnaFsdIFInfo* retval;

	retval=g_object_new(GJNA_TYPE_FSD_I_F_INFO, NULL);

	gtk_table_resize(GTK_TABLE(retval), GJnaFsdIFInfoKeyValueWidgets_LAST - 1, 2);
	impl_GJnaFsdIFInfo_addEntry(retval, GJnaFsdIFInfoKeyValueWidgets_NAME, "Name");
	impl_GJnaFsdIFInfo_addEntry(retval, GJnaFsdIFInfoKeyValueWidgets_VERSION, "Version");
	impl_GJnaFsdIFInfo_addEntry(retval, GJnaFsdIFInfoKeyValueWidgets_YEAR, "Year");
	impl_GJnaFsdIFInfo_addEntry(retval, GJnaFsdIFInfoKeyValueWidgets_LICENSE, "License");
	impl_GJnaFsdIFInfo_addEntry(retval, GJnaFsdIFInfoKeyValueWidgets_APPLICATION, "Application");
	impl_GJnaFsdIFInfo_addText(retval, GJnaFsdIFInfoKeyValueWidgets_INFOS, "Infos");
	
	return (GObject*) retval;
}

static void
impl_GJnaFsdIFInfo_setEntry		(GJnaFsdIFInfo* self,
					 GJnaFsdIFInfoKeyValueWidgetsNum num,
					 char* value)
{
	if(value) {
		gtk_entry_set_text(GTK_ENTRY(self->keyValue[num].value), value); 
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].value), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].key), TRUE);
	}
	else {
		gtk_entry_set_text(GTK_ENTRY(self->keyValue[num].value), ""); 
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].value), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].key), FALSE);
	}
}

static void
impl_GJnaFsdIFInfo_setText		(GJnaFsdIFInfo* self,
					 GJnaFsdIFInfoKeyValueWidgetsNum num,
					 char* value)
{
	GObject* textView;
		

	textView=g_object_get_data(G_OBJECT(self->keyValue[num].value), "textView");
	if(value) {
		gtk_text_buffer_set_text(GTK_TEXT_BUFFER(self->keyValue[num].value), value, -1);
		gtk_widget_set_sensitive(GTK_WIDGET(textView), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].key), TRUE);
	}
	else {
		gtk_text_buffer_set_text(GTK_TEXT_BUFFER(self->keyValue[num].value), "", -1);
		gtk_widget_set_sensitive(GTK_WIDGET(textView), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(self->keyValue[num].key), FALSE);
	}

}

void
GJnaFsdIFInfo_set		(GJnaFsdIFInfo* self,
				 char* name,
				 int version,
				 char* year,
				 char* license,
				 char* application,
				 char* infos)
{
	char* versionS;

	g_return_if_fail(GJNA_IS_FSD_I_F_INFO(self));

	impl_GJnaFsdIFInfo_setEntry(self, GJnaFsdIFInfoKeyValueWidgets_NAME, name);
	
	versionS=g_strdup_printf("%d", version);
	impl_GJnaFsdIFInfo_setEntry(self, GJnaFsdIFInfoKeyValueWidgets_VERSION, versionS);
	g_free(versionS);
	
	impl_GJnaFsdIFInfo_setEntry(self, GJnaFsdIFInfoKeyValueWidgets_YEAR, year);
	impl_GJnaFsdIFInfo_setEntry(self, GJnaFsdIFInfoKeyValueWidgets_LICENSE, license);
	impl_GJnaFsdIFInfo_setEntry(self, GJnaFsdIFInfoKeyValueWidgets_APPLICATION, application);
	impl_GJnaFsdIFInfo_setText(self, GJnaFsdIFInfoKeyValueWidgets_INFOS, infos);
}

