/* GtkJentchina
 * STRASSER Michel - 20040312		init
 * */

#include "GJnaFsdIFilter.h"
#include "GJnaFsdIFInfo.h"
#include "GJnaFsdIFAuthors.h"
#include "GJnaFsdIFPreview.h"
#include <glib.h>
#include <glib-object.h>
#include <gnome.h>

static GObjectClass *gjnaFsdIFilter_parentClass;

static void
impl_GJnaFsdIFilter_finalize(GObject *object)
{
	GJnaFsdIFilter *self=(GJnaFsdIFilter*)object;

	gtk_widget_hide(GTK_WIDGET(self));
	
	g_object_unref(G_OBJECT(self->vbox));
	g_object_unref(G_OBJECT(self->infoF));
	g_object_unref(G_OBJECT(self->info));
	g_object_unref(G_OBJECT(self->authorsF));
	g_object_unref(G_OBJECT(self->authors));
	g_object_unref(G_OBJECT(self->previewF));
	g_object_unref(G_OBJECT(self->preview));


	gjnaFsdIFilter_parentClass->finalize(object);
}

static void
GJnaFsdIFilterClass_init (GJnaFsdIFilterClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	gjnaFsdIFilter_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_GJnaFsdIFilter_finalize;
}


GType		GJnaFsdIFilter_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (GJnaFsdIFilterClass),
			NULL, NULL,
			(GClassInitFunc) GJnaFsdIFilterClass_init,
			NULL, NULL,
			sizeof (GJnaFsdIFilter),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			GTK_TYPE_HBOX,
			"GJnaFsdIFilter", &info, 0);
	}

	return type;
}

GObject* 	
GJnaFsdIFilter_new			()
{
	GJnaFsdIFilter* retval;

	retval=g_object_new(GJNA_TYPE_FSD_I_FILTER, NULL);

	retval->info=(GtkWidget*)GJnaFsdIFInfo_new();
	g_object_ref(G_OBJECT(retval->info));
	gtk_widget_show(GTK_WIDGET(retval->info));
	
	retval->infoF=gtk_frame_new("Info");
	g_object_ref(G_OBJECT(retval->infoF));
	gtk_widget_show(GTK_WIDGET(retval->infoF));
	gtk_container_add(GTK_CONTAINER(retval->infoF), retval->info);

	retval->authors=(GtkWidget*)GJnaFsdIFAuthors_new();
	g_object_ref(G_OBJECT(retval->authors));
	gtk_widget_show(GTK_WIDGET(retval->authors));
	
	retval->authorsF=gtk_frame_new("Authors");
	g_object_ref(G_OBJECT(retval->authorsF));
	gtk_widget_show(GTK_WIDGET(retval->authorsF));
	gtk_container_add(GTK_CONTAINER(retval->authorsF), retval->authors);
	
	retval->vbox=gtk_vbox_new(FALSE, 0);
	g_object_ref(retval->vbox);
	gtk_widget_show(GTK_WIDGET(retval->vbox));
	
	gtk_container_add(GTK_CONTAINER(retval->vbox), retval->infoF);
	gtk_container_add(GTK_CONTAINER(retval->vbox), retval->authorsF);

	retval->preview=(GtkWidget*)GJnaFsdIFPreview_new();
	g_object_ref(G_OBJECT(retval->preview));
	gtk_widget_show(GTK_WIDGET(retval->preview));
	
	retval->previewF=gtk_frame_new("Preview");
	g_object_ref(G_OBJECT(retval->previewF));
	gtk_widget_show(GTK_WIDGET(retval->previewF));
	gtk_container_add(GTK_CONTAINER(retval->previewF), retval->preview);
	
	gtk_container_add(GTK_CONTAINER(retval), retval->vbox);
	gtk_container_add(GTK_CONTAINER(retval), retval->previewF);
	
	return (GObject*) retval;
}

void
GJnaFsdIFilter_set		(GJnaFsdIFilter* self,
				 char* name,
				 int version,
				 char* year,
				 char* license,
				 char* application,
				 char* infos,
				 GList* authors,
				 char* preview)
{
	g_return_if_fail(GJNA_IS_FSD_I_FILTER(self));

	GJnaFsdIFInfo_set(GJNA_FSD_I_F_INFO(self->info), name, version, year, license, application, infos);
	GJnaFsdIFAuthors_set(GJNA_FSD_I_F_AUTHORS(self->authors), authors);
	GJnaFsdIFPreview_set(GJNA_FSD_I_F_PREVIEW(self->preview), preview);
}

