/* GtkJentchina
 * STRASSER Michel - 20040312		init
 * */


#include "GJnaFsdIServer.h"
#include <glib.h>
#include <glib-object.h>
#include <gnome.h>

static GObjectClass *gjnaFsdIServer_parentClass;

static void
impl_GJnaFsdIServer_finalize(GObject *object)
{
	GJnaFsdIServer *self=(GJnaFsdIServer*)object;

	gtk_widget_hide(GTK_WIDGET(self));
	g_object_unref(G_OBJECT(self->image));
	g_object_unref(G_OBJECT(self->label));
	gjnaFsdIServer_parentClass->finalize(object);
}

static void
GJnaFsdIServerClass_init (GJnaFsdIServerClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	gjnaFsdIServer_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_GJnaFsdIServer_finalize;
}

GType		GJnaFsdIServer_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (GJnaFsdIServerClass),
			NULL, NULL,
			(GClassInitFunc) GJnaFsdIServerClass_init,
			NULL, NULL,
			sizeof (GJnaFsdIServer),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			GTK_TYPE_HBOX,
			"GJnaFsdIServer", &info, 0);
	}

	return type;
}

GObject* 	
GJnaFsdIServer_new			()
{
	GJnaFsdIServer* retval;

	retval=g_object_new(GJNA_TYPE_FSD_I_SERVER, NULL);
	gtk_widget_set_usize(GTK_WIDGET(retval), 100, 100);

	gtk_box_set_homogeneous(GTK_BOX(retval), TRUE);

	retval->label=gtk_label_new("");
	g_object_ref(G_OBJECT(retval->label));
	gtk_widget_show(retval->label);
	gtk_box_pack_start(GTK_BOX(retval), retval->label, TRUE, TRUE, 0);
	
	retval->image=gtk_image_new();
	g_object_ref(G_OBJECT(retval->image));
	gtk_widget_show(retval->image);
	gtk_box_pack_start(GTK_BOX(retval), retval->image, TRUE, TRUE, 0);


	return (GObject*) retval;
}

void
GJnaFsdIServer_set			(GJnaFsdIServer* self,
					 char* name,
					 char* pic)
{
	g_return_if_fail(GJNA_IS_FSD_I_SERVER(self));

	gtk_label_set_text(GTK_LABEL(self->label), name);
	gtk_image_set_from_file(GTK_IMAGE(self->image), pic);
}

