/* GtkJentchina
 * STRASSER Michel - 20040312		init
 * */


#include "GJnaFsdInfo.h"
#include <glib.h>
#include <glib-object.h>
#include <gnome.h>
#include "GJnaFsdIServer.h"
#include "GJnaFsdIFilter.h"

static GObjectClass *gjnaFsdInfo_parentClass;

static void
impl_GJnaFsdInfo_finalize(GObject *object)
{
	GJnaFsdInfo *self=(GJnaFsdInfo*)object;

	gtk_widget_hide(GTK_WIDGET(self));
	g_object_unref(G_OBJECT(self->server));
	g_object_unref(G_OBJECT(self->serverF));
	g_object_unref(G_OBJECT(self->filter));
	g_object_unref(G_OBJECT(self->filterF));
	gjnaFsdInfo_parentClass->finalize(object);
}

static void
GJnaFsdInfoClass_init (GJnaFsdInfoClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	gjnaFsdInfo_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_GJnaFsdInfo_finalize;
}

GType		GJnaFsdInfo_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (GJnaFsdInfoClass),
			NULL, NULL,
			(GClassInitFunc) GJnaFsdInfoClass_init,
			NULL, NULL,
			sizeof (GJnaFsdInfo),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			GTK_TYPE_VBOX,
			"GJnaFsdInfo", &info, 0);
	}

	return type;
}

GObject* 	
GJnaFsdInfo_new			()
{
	GJnaFsdInfo* retval;

	retval=g_object_new(GJNA_TYPE_FSD_INFO, NULL);

	retval->server=(GtkWidget*)GJnaFsdIServer_new();
	g_object_ref(G_OBJECT(retval->server));
	gtk_widget_show(GTK_WIDGET(retval->server));
	
	retval->serverF=gtk_frame_new("Server");
	g_object_ref(G_OBJECT(retval->serverF));
	gtk_widget_show(GTK_WIDGET(retval->serverF));
	gtk_container_add(GTK_CONTAINER(retval->serverF), retval->server);

	gtk_container_add(GTK_CONTAINER(retval), retval->serverF);
	retval->filter=(GtkWidget*)GJnaFsdIFilter_new();
	g_object_ref(G_OBJECT(retval->filter));
	gtk_widget_show(GTK_WIDGET(retval->filter));
	
	retval->filterF=gtk_frame_new("Filter");
	g_object_ref(G_OBJECT(retval->filterF));
	gtk_widget_show(GTK_WIDGET(retval->filterF));
	gtk_container_add(GTK_CONTAINER(retval->filterF), retval->filter);

	gtk_container_add(GTK_CONTAINER(retval), retval->filterF);

	return (GObject*) retval;
}

void
GJnaFsdInfo_set			(GJnaFsdInfo* self,
				 char* serverName,
				 char* serverPic,
				 char* filterName,
				 int version,
				 char* year,
				 char* license,
				 char* application,
				 char* info,
				 GList* authors,
				 char* filterPic)
{
	g_return_if_fail(GJNA_IS_FSD_INFO(self));

	GJnaFsdIServer_set(GJNA_FSD_I_SERVER(self->server), serverName, serverPic);
	if(filterName) {
		GJnaFsdIFilter_set(GJNA_FSD_I_FILTER(self->filter),
			filterName, version, year, license, application, info, authors, filterPic);

		gtk_widget_set_sensitive(GTK_WIDGET(self->filterF), TRUE);
	}
	else
		gtk_widget_set_sensitive(GTK_WIDGET(self->filterF), FALSE);
}

