/* GtkJentchina
 * STRASSER Michel - 20040410		init
 * */


#include "GtkJentchinaObj.h"
#include <glib.h>
#include <glib-object.h>
#include "GJnaObj.h"
#include <lsmlib.h>
#include <IG.h>

static GObjectClass *gtkJentchinaObj_parentClass;

static void
impl_GtkJentchinaObj_finalize(GObject *object)
{
	GtkJentchinaObj *self=(GtkJentchinaObj*)object;

	g_object_unref(self->gjnaObj);

	gtkJentchinaObj_parentClass->finalize(object);
}

static void
GtkJentchinaObjClass_init (GtkJentchinaObjClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	int argc=0;
	char* argv[]={NULL};

	gtkJentchinaObj_parentClass = g_type_class_peek_parent (selfClass);

//	IG_init("GtkJentchina", "2.0", argc, argv);
	
	objectClass->finalize=impl_GtkJentchinaObj_finalize;
}

GType		GtkJentchinaObj_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (GtkJentchinaObjClass),
			NULL, NULL,
			(GClassInitFunc) GtkJentchinaObjClass_init,
			NULL, NULL,
			sizeof (GtkJentchinaObj),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"GtkJentchinaObj", &info, 0);
	}

	return type;
}

GObject* 	
GtkJentchinaObj_new		(char* appName)
{
	GtkJentchinaObj* retval;

	retval=g_object_new(GTK_JENTCHINA_TYPE_OBJ, NULL);

	retval->gjnaObj=GJnaObj_new(appName);

	return (GObject*) retval;
}

GtkJentchinaStatus
GtkJentchinaObj_applyFilter	(GtkJentchinaObj* self,
				 GtkJentchinaFilterType filterType,
				 LsmTree* in_input,
				 LsmTree** out_output)
{
	GtkJentchinaStatus retval=GtkJentchinaStatus_OK;

	g_return_val_if_fail(GTK_JENTCHINA_IS_OBJ(self), GtkJentchinaStatus_INVALID_OBJECT); 
	g_return_val_if_fail(filterType >= 0 && filterType < GtkJentchinaFilterType_NUM, GtkJentchinaStatus_INVALID_FILTER_TYPE); 
	g_return_val_if_fail(in_input, GtkJentchinaStatus_INVALID_DOC); 
	g_return_val_if_fail(out_output, GtkJentchinaStatus_INVALID_OUT_DOC_POINTER); 
	
	retval=(GtkJentchinaStatus)GJnaObj_applyFilter(GJNA_OBJ(self->gjnaObj), (GJnaFilterType)filterType, in_input, out_output);

	return retval;
}


